## exactimage 1.2.1

=== Makefile ===
include config.make

X_OUTARCH := objdir

X_BUILD_IMPLICIT=0
include utility/Makefile
X_BUILD_IMPLICIT=1

# -s silcently corrupts binaries on OS X, sigh -ReneR
CFLAGS := -Wall -O2 # -O1 -ggdb # -fsanitize=address -fsanitize=undefined

# for config.h
CPPFLAGS += -I .

# -frename-registers and -funroll-loops brings a lot performance on
# my AMD Turion - about 20% time decrease (though it is included in -funroll-loops anyway) !!!

# from the linux-kernel build system:
cc-option = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null \
            > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

ifeq "$(X_ARCH)" "i686"
CFLAGS += -march=i686
CFLAGS += $(call cc-option,-mtune=pentium4,)
CFLAGS += $(call cc-option,-mfpmath=sse,)
endif

# TODO: improve to match i[3456]86
ifneq  "$(X_ARCH)" "i686"
CFLAGS += -fPIC
endif

ifeq "$(X_ARCH)" "sparc64"
CFLAGS += -mcpu=ultrasparc
CFLAGS += $(call cc-option,-mtune=niagara,)
endif

CFLAGS += $(call cc-option,-march=native)

CFLAGS += -funroll-loops -fomit-frame-pointer
CFLAGS += $(call cc-option,-funswitch-loops,)
CFLAGS += $(call cc-option,-fpeel-loops,)
CFLAGS += $(call cc-option,-ftracer,)
CFLAGS += $(call cc-option,-funit-at-a-time,)
CFLAGS += $(call cc-option,-frename-registers,)
CFLAGS += $(call cc-option,-ftree-vectorize,)

# we have some unimplemented colorspaces in the Image::iterator :-(
CFLAGS += $(call cc-option,-Wno-switch -Wno-switch-enum,)

CXXFLAGS := $(CFLAGS) -Wno-sign-compare

ifeq "$(STATIC)" "1"
X_EXEFLAGS += -static
endif

MODULES = image codecs bardecode frontends ContourMatching
include $(addsuffix /Makefile,$(MODULES))

ifeq "$(WITHX11)" "1"
ifeq "$(WITHEVAS)" "1"
include gfx/Makefile
include edisplay/Makefile
endif
endif

ifeq "$(WITHSWIG)" "1"
include api/Makefile

ifeq "$(WITHLUA)" "1"
include api/lua/Makefile
endif
ifeq "$(WITHPERL)" "1"
include api/perl/Makefile
endif
ifeq "$(WITHPHP)" "1"
include api/php/Makefile
endif
ifeq "$(WITHPYTHON)" "1"
include api/python/Makefile
endif
ifeq "$(WITHRUBY)" "1"
include api/ruby/Makefile
endif

endif

check: $(X_OUTARCH)/econvert/econvert$(X_EXEEXT) $(X_OUTARCH)/edentify/edentify$(X_EXEEXT)
	$(Q)cd testsuite; ./run ../$(X_OUTARCH)/econvert/econvert$(X_EXEEXT)

=== ContourMatching/Makefile ===
include build/top.make

# build each .cc file as executable - if this is not desired
# in the future a list must be supplied manually ...
BINARY = $(basename $(notdir $(wildcard $(X_MODULE)/*.cc)))

BINARY_EXT = $(X_EXEEXT)
DEPS = $(image_BINARY) $(codecs_BINARY) $(X_OUTARCH)/utility/ArgumentList$(X_OBJEXT)

CPPFLAGS += -I utility

X_NO_INSTALL := 1
include build/bottom.make
X_NO_INSTALL := 0

=== api/Makefile ===
include build/top.make

BINARY = api
BINARY_EXT = $(X_LIBEXT)
DEPS = 

ifeq "$(WITHBARDECODE)" "1"
CPPFLAGS += $(BARDECODEINCS)
LDFLAGS += $(BARDECODELIBS)
endif

$(X_MODULE)/api.cc/CXXFLAGS := -fpermissive

# we have an own install
_X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)
X_BUILD_IMPLICIT := 0
include build/bottom.make
X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)

=== bardecode/Makefile ===
include build/top.make

BINARY = bardecode
BINARY_EXT = $(X_LIBEXT)
DEPS = 

CPPFLAGS += -I bardecode
$($(X_MODULE)_OUTPUT)/CXXFLAGS := -fpermissive

include build/bottom.make

=== codecs/Makefile ===
include build/top.make

ifeq "$(WITHLIBJPEG)" "1"
LDFLAGS += -ljpeg
else
NOT_SRCS += jpeg.cc transupp.c
endif

ifeq "$(WITHLIBJXL)" "1"
LDFLAGS += $(LIBJXLLIBS) -ljxl_threads
else
NOT_SRCS += jpegxl.cc
endif

ifeq "$(WITHLIBHEIF)" "1"
LDFLAGS += $(LIBHEIFIBS) -lheif
else
NOT_SRCS += heif.cc
endif

ifeq "$(WITHLIBTIFF)" "1"
LDFLAGS += -ltiff # -ltiffxx
else
NOT_SRCS += tiff.cc
endif

ifeq "$(WITHLIBPNG)" "1"
LDFLAGS += -lpng
else
NOT_SRCS += png.cc
endif

ifeq "$(WITHLIBGIF)" "1"
LDFLAGS += -lgif
else
NOT_SRCS += gif.cc
endif

ifeq "$(WITHJASPER)" "1"
LDFLAGS += -ljasper
else
NOT_SRCS += jpeg2000.cc
endif

ifeq "$(WITHOPENEXR)" "1"
CPPFLAGS += $(OPENEXRINCS)
LDFLAGS += $(OPENEXRLIBS)
else
NOT_SRCS += openexr.cc
endif

ifeq "$(WITHLCMS)" "1"
LDFLAGS += $(LCMSLIBS)
endif

ifeq "$(WITHEXPAT)" "1"
LDFLAGS += $(EXPATLIBS)
else
NOT_SRCS += agg_svg_parser.cc agg_svg_path_renderer.cc \
            agg_svg_path_tokenizer.cc svg.cc
endif

ifeq "$(PCX)" "0"
NOT_SRCS += pcx.cc
endif

ifeq "$(TGA)" "0"
NOT_SRCS += tga.cc
endif 

BINARY = codecs
BINARY_EXT = $(X_LIBEXT)
DEPS =

CPPFLAGS += -I codecs/
LDFLAGS += -lz # for the PDF compression, TODO: check for availability and disable the support code otherwise

include build/bottom.make

=== edisplay/Makefile ===
include build/top.make

BINARY = edisplay
BINARY_EXT = $(X_EXEEXT)

CPPFLAGS += -I . -I lib -I gfx
CPPFLAGS +=  $(shell pkg-config evas --atleast-version 0.9.9.050 && echo -D WITHEVAS_X11_CONNECTION)
CPPFLAGS +=  $(shell pkg-config evas --atleast-version 0.9.9.49898 && echo -D WITHEVAS_X11_SCREEN)

DEPS += $(X_OUTARCH)/gfx/X11Helper$(X_OBJEXT) $(X_OUTARCH)/gfx/EvasHelper$(X_OBJEXT) $(X_OUTARCH)/utility/Timer$(X_OBJEXT) $(X_OUTARCH)/utility/ArgumentList$(X_OBJEXT) $(image_BINARY) $(codecs_BINARY)

include build/bottom.make

=== frontends/Makefile ===
include build/top.make

ifneq "$(WITHLIBTIFF)" "1"
NOT_SRCS += e2mtiff.cc
endif

# build each .cc file as executable - if this is not desired
# in the future a list must be supplied manually ...

BINARY = $(basename $(filter-out $(NOT_SRCS), $(notdir $(wildcard $(X_MODULE)/*.cc $(X_MODULE)/*.c))) $(SRCS))

BINARY_EXT = $(X_EXEEXT)
DEPS = $(image_BINARY) $(codecs_BINARY) $(bardecode_BINARY) $(X_OUTARCH)/utility/ArgumentList$(X_OBJEXT) $(X_OUTARCH)/utility/File$(X_OBJEXT)

CPPFLAGS += -I utility
#LDFLAGS += -lGL -lGLU -lglut -L/usr/X11/lib64

$(X_MODULE)/bardecode.cc/CXXFLAGS := -fpermissive
$(X_MODULE)/econvert.cc/CXXFLAGS := -fpermissive

include build/bottom.make

=== image/Makefile ===
include build/top.make

BINARY = image
BINARY_EXT = $(X_LIBEXT)
DEPS =

# as fallback use the built-in Agg, we depend on it, ...

CPPFLAGS += $(LIBAGGINCS)
LDFLAGS += $(LIBAGGLIBS)
ifeq "$(WITHFREETYPE)" "1"
LDFLAGS += -laggfontfreetype
endif

ifeq "$(WITHFREETYPE)" "1"
CPPFLAGS += $(FREETYPEINCS)
LDFLAGS += $(FREETYPELIBS) 
endif

CPPFLAGS += -I image -I utility

include build/bottom.make

=== utility/Makefile ===
include build/top.make

NOT_INCS := BinomiHeap.hh
NOT_SRCS += Lua.cc

BINARY = libgsmutil
BINARY_EXT = $(X_DYNEXT)
DEPS =

CXXFLAGS += -I utility/
LDFLAGS += $(SIGC2LIBS) # -ldl -pthread 

include build/bottom.make

=== api/lua/Makefile ===
include build/top.make

BINARY = ExactImage
BINARY_EXT = $(X_DYNEXT)
DEPS = $(image_BINARY) $(bardecode_BINARY) $(codecs_BINARY) $(api_BINARY) $($(X_MODULE)_OUTPUT)/api-lua-wrap.cc

$($(X_MODULE)_OUTPUT)/CXXFLAGS := -I api $(LUAINCS) -fno-strict-aliasing

$($(X_MODULE)_OUTPUT)/api-lua-wrap.cc: $(X_MODULE)/../api.hh $(X_MODULE)/../api-swig.hh
	$(Q)echo "  SWIG      $(dir $@)"
	$(Q)swig -lua -c++ -outdir $(dir $@) -o '$@' $(X_MODULE)/../api-swig.hh

# we have an own install
_X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)
X_BUILD_IMPLICIT := 0
include build/bottom.make
X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)

api/lua/libdir := $(shell pkg-config lua --variable INSTALL_CMOD)

# install
all:: $($(X_MODULE)_BINARY)
install:: $($(X_MODULE)_BINARY)
	$(Q)echo "INSTALL LUA module $^"
	$(Q)mkdir -p $(DESTDIR)$(api/lua/libdir)
	$(Q)install $^ $(DESTDIR)$(api/lua/libdir)

=== api/perl/Makefile ===
include build/top.make

BINARY = ExactImage
BINARY_EXT = $(X_DYNEXT)
DEPS = $(image_BINARY) $(bardecode_BINARY) $(codecs_BINARY) $(api_BINARY) $($(X_MODULE)_OUTPUT)/api-perl-wrap.cc

$($(X_MODULE)_OUTPUT)/CXXFLAGS := -I api $(PERLINCS)

$($(X_MODULE)_OUTPUT)/api-perl-wrap.cc: $(X_MODULE)/../api.hh $(X_MODULE)/../api-swig.hh
	$(Q)echo "  SWIG      $(dir $@)"
	$(Q)swig -perl -c++ -outdir $(dir $@) -o '$@' $(X_MODULE)/../api-swig.hh

# we have an own install
_X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)
X_BUILD_IMPLICIT := 0
include build/bottom.make
X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)

# install
all:: $($(X_MODULE)_BINARY)
install:: $($(X_MODULE)_BINARY)
	$(Q)echo "INSTALL PERL module $^"
	$(Q)mkdir -p $(DESTDIR)$(libdir)/perl5/site_perl/
	$(Q)install $^ $(dir $^)/ExactImage.pm $(DESTDIR)$(libdir)/perl5/site_perl/

=== api/php/Makefile ===
include build/top.make

BINARY = ExactImage
BINARY_EXT = $(X_DYNEXT)
DEPS = $(image_BINARY) $(bardecode_BINARY) $(codecs_BINARY) $(api_BINARY) $($(X_MODULE)_OUTPUT)/api-php-wrap.cc

$($(X_MODULE)_OUTPUT)/CXXFLAGS := -I api $(PHPINCS) -fno-strict-aliasing

$($(X_MODULE)_OUTPUT)/api-php-wrap.cc: $(X_MODULE)/../api.hh $(X_MODULE)/../api-swig.hh
	$(Q)echo "  SWIG      $(dir $@)"
	$(Q)swig -php -c++ -outdir $(dir $@) -o '$@' $(X_MODULE)/../api-swig.hh

# we have an own install
_X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)
X_BUILD_IMPLICIT := 0
include build/bottom.make
X_BUILD_IMPLICIT := $(_X_BUILD_IMPLICIT)

# install
all:: $($(X_MODULE)_BINARY)
install:: $($(X_MODULE)_BINARY)
	$(Q)echo "INSTALL PHP module $^"
	$(Q)mkdir -p $(DESTDIR)$(libdir)/php/
	$(Q)install $^ $(DESTDIR)$(libdir)/php/

=== debian/changelog ===
exactimage (1.2.1-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.7.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 01 Mar 2025 20:57:45 +0100

exactimage (1.2.1-1) unstable; urgency=medium

  * New Upstream Version
  * Update debian/copyright
  * debian/control:
    - Add support for HEIF image format via libheif-dev

 -- Sven Eckelmann <sven@narfation.org>  Thu, 16 Jan 2025 19:02:50 +0100

exactimage (1.0.2-12) unstable; urgency=medium

  * debian/rules:
    - Use DEB_BUILD_MAINT_OPTIONS to set lfs flag
  * debian/control:
    - Replace pkg-config with pkgconf
    - Explicitly depend on python3-setuptools for distutils.sysconfig module
      (Closes: #1080594)

 -- Sven Eckelmann <sven@narfation.org>  Thu, 05 Sep 2024 17:11:22 +0200

exactimage (1.0.2-11) unstable; urgency=medium

  [ Debian Janitor ]
  * Update renamed lintian tag names in lintian overrides.

  [ Sven Eckelmann ]
  * debian/control:
    - Upgraded to policy 4.6.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 31 Dec 2022 09:48:30 +0100

exactimage (1.0.2-10) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove overrides for lintian tags that are no longer supported.

  [ Sven Eckelmann ]
  * debian/control:
    - Remove constraints unnecessary since buster (oldstable):
      + exactimage-perl: Drop versioned constraint on exactimage-perl in
        Breaks + Replaces.
    - Replace Build-Depends libtiff5-dev with libtiff-dev
    - Replace Build-Depends libfreetype6-dev with libfreetype-dev
    - Upgraded to policy 4.6.1, no changes required
    - Drop unused lintian override spelling-error-in-binary
  * debian/copyright:
    - Update copyright years to 2022

 -- Sven Eckelmann <sven@narfation.org>  Mon, 14 Nov 2022 18:23:26 +0100

exactimage (1.0.2-9) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.6.0, no changes required
    - Switch to correct DEP-14 unstable branch name
    - Remove versioned constraints unnecessary since buster
  * debian/patches:
    - Add openexr-Fix-FTBFS-due-to-usage-of-deprecated-Int64-data-t.patch,
      Fix FTBFS due to usage of deprecated Int64 data types (Closes: #1017510)
    - Add code25i-Fix-const-initialization-of-non-integral-static-v.patch,
      Fix const initialization of non-integral static variables

 -- Sven Eckelmann <sven@narfation.org>  Wed, 17 Aug 2022 12:48:23 +0200

exactimage (1.0.2-8) unstable; urgency=medium

  * debian/control
    - Move repository to from ecsv-guest to ecsv salsa user
    - Upgraded to policy 4.5.0, no changes required
    - Switch to debhelper compat 13
  * debian/copyright
    - Update copyright years to 2020
  * Drop duplicated fields from upstream/metadata
  * Update debian/watch for format 4
  * debian/rules:
    - Drop default flag --as-needed from linker flags
    - Add -fpermissive to fix FTBFS due to missing C++11 "constexp"
  * debian/patches:
    - Add adapt-for-nicer-per-file-_C-FLAGS-per-source-input-name.patch,
      added-fpermissive-where-currently-necessary.patch,
      if-we-can-not-easily-use-the-input-module-name-for-C-FLAS.patch,
      Updated-per-file-C-FLAGS-to-likely-final-delimiter.patch,
      Fix build with C++11 and OpenEXR 2.5.x (Closes: #968829)

 -- Sven Eckelmann <sven@narfation.org>  Sat, 22 Aug 2020 11:27:35 +0200

=== debian/control ===
Source: exactimage
Section: graphics
Priority: optional
Maintainer: Sven Eckelmann <sven@narfation.org>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://exactcode.com/opensource/exactimage/
Vcs-Git: https://salsa.debian.org/ecsv/exactimage.git -b debian/unstable
Vcs-Browser: https://salsa.debian.org/ecsv/exactimage
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 docbook-xml,
 docbook-xsl,
 libagg2-dev,
 libexpat-dev,
 libfreetype-dev,
 libgif-dev,
 libheif-dev,
 libjpeg-dev,
 libopenexr-dev,
 libperl-dev,
 libpng-dev,
 libtiff-dev,
 libx11-dev,
 libxml2-utils,
 perl,
 pkgconf,
 python3-all-dev,
 python3-setuptools,
 swig,
 xsltproc,

Package: exactimage
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: fast image manipulation programs
 ExactImage is a fast C++ image processing library. Unlike many other library
 frameworks it allows operation in several color spaces and bit depths
 natively, resulting in low memory and computational requirements.
 .
 This package contains the utilities.

Package: libexactimage-perl
Section: perl
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Description: fast image manipulation library (Perl bindings)
 ExactImage is a fast C++ image processing library. Unlike many other library
 frameworks it allows operation in several color spaces and bit depths
 natively, resulting in low memory and computational requirements.
 .
 This package contains the Perl bindings.

Package: python3-exactimage
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
Description: fast image manipulation library (Python3 bindings)
 ExactImage is a fast C++ image processing library. Unlike many other library
 frameworks it allows operation in several color spaces and bit depths
 natively, resulting in low memory and computational requirements.
 .
 This package contains the Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all abi=+lfs
export DEB_CFLAGS_MAINT_APPEND=-fopenmp -ffunction-sections -fdata-sections -fpermissive
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--gc-sections
PERL_ARCHLIB := $(shell perl -MConfig -e 'print $$Config{vendorarch}')

MAKEOPTIONS = X_SYSTEM=Linux Q=

MAKE := $(MAKE) X_SYSTEM=Linux Q=

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --with=python3

override_dh_auto_configure:
	./configure --prefix=/usr --includedir=/usr/include --mandir=/usr/share/man --infodir=/usr/share/info --sysconfdir=/etc --libdir=/usr/lib --libexecdir=/usr/lib --with-ruby=no --with-php=no --with-evas=no

override_dh_auto_clean:
	touch config.make
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_test:

override_dh_auto_build:
	mkdir -p objdir/api/python/
	touch objdir/api/python/_ExactImage.so # prevent from being built this time
	dh_auto_build -- all $(MAKEOPTIONS)
	set -e; \
	for python in $(shell py3versions -r); do \
		rm -f objdir/api/python/_ExactImage.so; \
		dh_auto_build -- $(MAKEOPTIONS) objdir/api/python/_ExactImage.so PYTHONINCS=`$$python-config --includes`; \
		mkdir -p objdir/api/$$python; \
		PYEXT=$$($${python} -c 'from distutils.sysconfig import get_config_var; print(get_config_var("EXT_SUFFIX"))'); \
		cp objdir/api/python/_ExactImage.so objdir/api/$$python/_ExactImage$${PYEXT}; \
		cp objdir/api/python/ExactImage.py objdir/api/$$python/; \
		chmod a-x objdir/api/$$python/*; \
	done
	$(MAKE) -C debian/manpages/

override_dh_auto_install:
	sed -e 's,$${perl_archlib},$(PERL_ARCHLIB),g' debian/libexactimage-perl.install.in > debian/libexactimage-perl.install
	dh_auto_install -- $(MAKEOPTIONS) WITHPYTHON=0
	set -e; \
	for python in $(shell py3versions -r); do \
		PYDIR=$$($${python} -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())'); \
		mkdir -p debian/tmp/$${PYDIR}; \
		cp -a objdir/api/$$python/* debian/tmp/$${PYDIR}; \
	done

override_dh_shlibdeps:
	dh_shlibdeps
	sed -i -e '/shlibs:Depends.*\(libevas[^ ]*\).*/ { p; s//evas:Depends=\1-engines-x/; b }; /^evas:Depends=/d' debian/*.substvars

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_configure override_dh_auto_build override_dh_auto_install override_dh_shlibdeps override_dh_auto_clean override_dh_auto_test
